<?php

namespace Sabre\DesignatePrinter\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BoardingPass Structs
 * @subpackage Structs
 */
class BoardingPass extends AbstractStructBase
{
    /**
     * The HostedCarrier
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $HostedCarrier;
    /**
     * The LNIATA
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $LNIATA;
    /**
     * The Undesignate
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $Undesignate;
    /**
     * Constructor method for BoardingPass
     * @uses BoardingPass::setHostedCarrier()
     * @uses BoardingPass::setLNIATA()
     * @uses BoardingPass::setUndesignate()
     * @param bool $hostedCarrier
     * @param string $lNIATA
     * @param bool $undesignate
     */
    public function __construct($hostedCarrier = null, $lNIATA = null, $undesignate = null)
    {
        $this
            ->setHostedCarrier($hostedCarrier)
            ->setLNIATA($lNIATA)
            ->setUndesignate($undesignate);
    }
    /**
     * Get HostedCarrier value
     * @return bool|null
     */
    public function getHostedCarrier()
    {
        return $this->HostedCarrier;
    }
    /**
     * Set HostedCarrier value
     * @param bool $hostedCarrier
     * @return \Sabre\DesignatePrinter\Structs\BoardingPass
     */
    public function setHostedCarrier($hostedCarrier = null)
    {
        $this->HostedCarrier = $hostedCarrier;
        return $this;
    }
    /**
     * Get LNIATA value
     * @return string|null
     */
    public function getLNIATA()
    {
        return $this->LNIATA;
    }
    /**
     * Set LNIATA value
     * @param string $lNIATA
     * @return \Sabre\DesignatePrinter\Structs\BoardingPass
     */
    public function setLNIATA($lNIATA = null)
    {
        $this->LNIATA = $lNIATA;
        return $this;
    }
    /**
     * Get Undesignate value
     * @return bool|null
     */
    public function getUndesignate()
    {
        return $this->Undesignate;
    }
    /**
     * Set Undesignate value
     * @param bool $undesignate
     * @return \Sabre\DesignatePrinter\Structs\BoardingPass
     */
    public function setUndesignate($undesignate = null)
    {
        $this->Undesignate = $undesignate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\DesignatePrinter\Structs\BoardingPass
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
