<?php

namespace Sabre\DesignatePrinter\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DesignatePrinterRQ Structs
 * @subpackage Structs
 */
class DesignatePrinterRQ extends AbstractStructBase
{
    /**
     * The Version
     * Meta informations extracted from the WSDL
     * - fixed: 2.0.1
     * - use: required
     * @var string
     */
    public $Version;
    /**
     * The Printers
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\DesignatePrinter\Structs\Printers
     */
    public $Printers;
    /**
     * The Profile
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sabre\DesignatePrinter\Structs\Profile
     */
    public $Profile;
    /**
     * The ReturnHostCommand
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $ReturnHostCommand;
    /**
     * The TimeStamp
     * Meta informations extracted from the WSDL
     * - use: optional
     * - documentation: A date time type that forces both date and time to be specified. A year and seconds are allowed to be omitted. Example formats: "yyyy-mm-ddThh:mm:ss", "mm-ddThh:mm:ss", "mm-ddThh:mm", "yyyy-mm-ddThh:mm"
     * - pattern:
     * (((((0[1-9])|(1[0-2]))-((0[1-9])|(1\d)|(2[0-9])))|((((0[13578])|(1[02]))-31)|(((0[1,3-9])|(1[0-2]))-30)))|(((19|20)(([02468][048])|([13579][26]))-02-29))|((20[0-9][0-9])|(19[0-9][0-9]))-((((0[1-9])|(1[0-2]))-((0[1-9])|(1\d)|(2[0-8])))|((((0[13578])|(
     * 1[02]))-31)|(((0[1,3-9])|(1[0-2]))-(29|30)))))T([0-1][0-9]|[2][0-3])(:([0-5][0-9])){1,2}
     * @var string
     */
    public $TimeStamp;
    /**
     * Constructor method for DesignatePrinterRQ
     * @uses DesignatePrinterRQ::setVersion()
     * @uses DesignatePrinterRQ::setPrinters()
     * @uses DesignatePrinterRQ::setProfile()
     * @uses DesignatePrinterRQ::setReturnHostCommand()
     * @uses DesignatePrinterRQ::setTimeStamp()
     * @param string $version
     * @param \Sabre\DesignatePrinter\Structs\Printers $printers
     * @param \Sabre\DesignatePrinter\Structs\Profile $profile
     * @param bool $returnHostCommand
     * @param string $timeStamp
     */
    public function __construct($version = null, \Sabre\DesignatePrinter\Structs\Printers $printers = null, \Sabre\DesignatePrinter\Structs\Profile $profile = null, $returnHostCommand = null, $timeStamp = null)
    {
        $this
            ->setVersion($version)
            ->setPrinters($printers)
            ->setProfile($profile)
            ->setReturnHostCommand($returnHostCommand)
            ->setTimeStamp($timeStamp);
    }
    /**
     * Get Version value
     * @return string
     */
    public function getVersion()
    {
        return $this->Version;
    }
    /**
     * Set Version value
     * @param string $version
     * @return \Sabre\DesignatePrinter\Structs\DesignatePrinterRQ
     */
    public function setVersion($version = null)
    {
        $this->Version = $version;
        return $this;
    }
    /**
     * Get Printers value
     * @return \Sabre\DesignatePrinter\Structs\Printers|null
     */
    public function getPrinters()
    {
        return $this->Printers;
    }
    /**
     * Set Printers value
     * @param \Sabre\DesignatePrinter\Structs\Printers $printers
     * @return \Sabre\DesignatePrinter\Structs\DesignatePrinterRQ
     */
    public function setPrinters(\Sabre\DesignatePrinter\Structs\Printers $printers = null)
    {
        $this->Printers = $printers;
        return $this;
    }
    /**
     * Get Profile value
     * @return \Sabre\DesignatePrinter\Structs\Profile|null
     */
    public function getProfile()
    {
        return $this->Profile;
    }
    /**
     * Set Profile value
     * @param \Sabre\DesignatePrinter\Structs\Profile $profile
     * @return \Sabre\DesignatePrinter\Structs\DesignatePrinterRQ
     */
    public function setProfile(\Sabre\DesignatePrinter\Structs\Profile $profile = null)
    {
        $this->Profile = $profile;
        return $this;
    }
    /**
     * Get ReturnHostCommand value
     * @return bool|null
     */
    public function getReturnHostCommand()
    {
        return $this->ReturnHostCommand;
    }
    /**
     * Set ReturnHostCommand value
     * @param bool $returnHostCommand
     * @return \Sabre\DesignatePrinter\Structs\DesignatePrinterRQ
     */
    public function setReturnHostCommand($returnHostCommand = null)
    {
        $this->ReturnHostCommand = $returnHostCommand;
        return $this;
    }
    /**
     * Get TimeStamp value
     * @return string|null
     */
    public function getTimeStamp()
    {
        return $this->TimeStamp;
    }
    /**
     * Set TimeStamp value
     * @param string $timeStamp
     * @return \Sabre\DesignatePrinter\Structs\DesignatePrinterRQ
     */
    public function setTimeStamp($timeStamp = null)
    {
        $this->TimeStamp = $timeStamp;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\DesignatePrinter\Structs\DesignatePrinterRQ
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
